<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SubsidiaryTaxRegistrationList StructType
 * @subpackage Structs
 */
class SubsidiaryTaxRegistrationList extends AbstractStructBase
{
    /**
     * The subsidiaryTaxRegistration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SubsidiaryTaxRegistration[]
     */
    public $subsidiaryTaxRegistration;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for SubsidiaryTaxRegistrationList
     * @uses SubsidiaryTaxRegistrationList::setSubsidiaryTaxRegistration()
     * @uses SubsidiaryTaxRegistrationList::setReplaceAll()
     * @param \StructType\SubsidiaryTaxRegistration[] $subsidiaryTaxRegistration
     * @param bool $replaceAll
     */
    public function __construct(array $subsidiaryTaxRegistration = array(), $replaceAll = true)
    {
        $this
            ->setSubsidiaryTaxRegistration($subsidiaryTaxRegistration)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get subsidiaryTaxRegistration value
     * @return \StructType\SubsidiaryTaxRegistration[]|null
     */
    public function getSubsidiaryTaxRegistration()
    {
        return $this->subsidiaryTaxRegistration;
    }
    /**
     * This method is responsible for validating the values passed to the setSubsidiaryTaxRegistration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSubsidiaryTaxRegistration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSubsidiaryTaxRegistrationForArrayConstraintsFromSetSubsidiaryTaxRegistration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $subsidiaryTaxRegistrationListSubsidiaryTaxRegistrationItem) {
            // validation for constraint: itemType
            if (!$subsidiaryTaxRegistrationListSubsidiaryTaxRegistrationItem instanceof \StructType\SubsidiaryTaxRegistration) {
                $invalidValues[] = is_object($subsidiaryTaxRegistrationListSubsidiaryTaxRegistrationItem) ? get_class($subsidiaryTaxRegistrationListSubsidiaryTaxRegistrationItem) : sprintf('%s(%s)', gettype($subsidiaryTaxRegistrationListSubsidiaryTaxRegistrationItem), var_export($subsidiaryTaxRegistrationListSubsidiaryTaxRegistrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The subsidiaryTaxRegistration property can only contain items of type \StructType\SubsidiaryTaxRegistration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set subsidiaryTaxRegistration value
     * @throws \InvalidArgumentException
     * @param \StructType\SubsidiaryTaxRegistration[] $subsidiaryTaxRegistration
     * @return \StructType\SubsidiaryTaxRegistrationList
     */
    public function setSubsidiaryTaxRegistration(array $subsidiaryTaxRegistration = array())
    {
        // validation for constraint: array
        if ('' !== ($subsidiaryTaxRegistrationArrayErrorMessage = self::validateSubsidiaryTaxRegistrationForArrayConstraintsFromSetSubsidiaryTaxRegistration($subsidiaryTaxRegistration))) {
            throw new \InvalidArgumentException($subsidiaryTaxRegistrationArrayErrorMessage, __LINE__);
        }
        $this->subsidiaryTaxRegistration = $subsidiaryTaxRegistration;
        return $this;
    }
    /**
     * Add item to subsidiaryTaxRegistration value
     * @throws \InvalidArgumentException
     * @param \StructType\SubsidiaryTaxRegistration $item
     * @return \StructType\SubsidiaryTaxRegistrationList
     */
    public function addToSubsidiaryTaxRegistration(\StructType\SubsidiaryTaxRegistration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SubsidiaryTaxRegistration) {
            throw new \InvalidArgumentException(sprintf('The subsidiaryTaxRegistration property can only contain items of type \StructType\SubsidiaryTaxRegistration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->subsidiaryTaxRegistration[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\SubsidiaryTaxRegistrationList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
